// RAMpageConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "windowsx.h"
#include "RAMpageConfig.h"
#include "RAMpageConfigDlg.h"

extern "C"
{
#include "RAMpageReg.h"
}

#define MBYTE ((DWORD)1024 * (DWORD)1024)
#define HALF_MBYTE ((DWORD)512 * (DWORD)1024)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnFaqs();
	afx_msg void OnHome();
	afx_msg void OnEmail();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
//	m_AboutHelp.LoadString(IDS_ABOUT_HELP);
//	m_AboutTitle.LoadString(IDS_ABOUT_TITLE);
//	m_ButtonCancelDesc.LoadString(IDS_BUTTON_CANCEL_DESC);
//	m_ButtonDefaultsDesc.LoadString(IDS_BUTTON_DEFAULTS_DESC);
//	m_ButtonOkDesc.LoadString(IDS_BUTTON_OK_DESC);
//	m_Buttons.LoadString(IDS_BUTTONS);
//	m_Defrag.LoadString(IDS_DEFRAG);
//	m_DefragDesc.LoadString(IDS_DEFRAG_DESC);
//	m_MemToFree.LoadString(IDS_MEM_TO_FREE);
//	m_MemToFreeDesc.LoadString(IDS_MEM_TO_FREE_DESC);
//	m_MemToFreeMax.LoadString(IDS_MEM_TO_FREE_MAX);
//	m_Threshold.LoadString(IDS_THRESHOLD);
//	m_ThresholdDesc.LoadString(IDS_THRESHOLD_DESC);
//	m_ThresholdMax.LoadString(IDS_THRESHOLD_MAX);
//	m_TopTip.LoadString(IDS_TOP_TIP);
//	m_Update.LoadString(IDS_UPDATE);
//	m_UpdateDesc.LoadString(IDS_UPDATE_DESC);
//	m_UpdateMinMax.LoadString(IDS_UPDATE_MINMAX);
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_FAQS, OnFaqs)
	ON_BN_CLICKED(IDC_HOME, OnHome)
	ON_BN_CLICKED(IDC_EMAIL, OnEmail)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRAMpageConfigDlg dialog

CRAMpageConfigDlg::CRAMpageConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRAMpageConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRAMpageConfigDlg)
	m_Memory = 0;
	m_Threshold = 0;
	m_Update = 0;
	m_AutoStart = TRUE;
	m_RunHidden = FALSE;
	m_Sound = FALSE;
	m_AlwaysFree = FALSE;
	m_MemoryToReach = 0;
	m_Free = FALSE;
	m_Reach = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
	m_Space = " ";
//	m_AttemptToFree.LoadString(IDS_ATTEMPT_TO_FREE);
//	m_Desc.LoadString(IDS_DESC);
//	m_FreeAuto.LoadString(IDS_FREE_AUTO);
//	m_MBytes1.LoadString(IDS_MBYTES_1_2);
//	m_MBytes2.LoadString(IDS_MBYTES_1_2);
//	m_Seconds.LoadString(IDS_SECONDS);
//	m_UpdateEvery.LoadString(IDS_UPDATE_EVERY);
//	m_Defragmnt.LoadString(IDS_DEFRAGMNT);
//	m_Details.LoadString(IDS_DETAILS);
//	m_WhenLow.LoadString(IDS_WHEN_LOW);
//	m_Always.LoadString(IDS_ALWAYS);
//	m_Never.LoadString(IDS_NEVER);
//	m_MBytes.LoadString(IDS_MBYTES);
//	m_Bytes.LoadString(IDS_BYTES);
//	m_AutoStartStr.LoadString(IDS_AUTOSTART);
//	m_RunHiddenStr.LoadString(IDS_RUNHIDDEN);
//	m_SoundStr.LoadString(IDS_SOUND);
//	m_.LoadString(IDS_);
}

void CRAMpageConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	MEMORYSTATUS memstat;
	unsigned int maxmem;

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRAMpageConfigDlg)
	DDX_Control(pDX, IDC_BUTTON_DEFAULTS, m_ButtonDefaults);
	DDX_Control(pDX, IDC_RADIO_GRAPH3, m_DisplayGraph3);
	DDX_Control(pDX, IDC_RADIO_GRAPH2, m_DisplayGraph2);
	DDX_Control(pDX, IDC_RADIO_GRAPH1, m_DisplayGraph1);
	DDX_Control(pDX, IDC_RADIO_NEVER, m_DefragNever);
	DDX_Control(pDX, IDC_RADIO_LOW, m_DefragLow);
	DDX_Control(pDX, IDC_RADIO_ALWAYS, m_DefragAlways);
	DDX_Control(pDX, IDC_RADIO_BYTES, m_DetailBytes);
	DDX_Control(pDX, IDC_RADIO_WHITE, m_DisplayWhite);
	DDX_Control(pDX, IDC_RADIO_NORMAL, m_DisplayNormal);
	DDX_Control(pDX, IDC_RADIO_GREEN, m_DisplayGreen);
	DDX_Control(pDX, IDC_RADIO_MBYTES, m_DetailMBytes);
	DDX_Text(pDX, IDC_EDIT_MEMORY, m_Memory);
	DDX_Text(pDX, IDC_EDIT_THRESHOLD, m_Threshold);
	DDX_Text(pDX, IDC_EDIT_UPDATE, m_Update);
	DDV_MinMaxUInt(pDX, m_Update, 1, 600);
	DDX_Check(pDX, IDC_CHECK_AUTOSTART, m_AutoStart);
	DDX_Check(pDX, IDC_CHECK_RUNHIDDEN, m_RunHidden);
	DDX_Check(pDX, IDC_CHECK_SOUND, m_Sound);
	DDX_Check(pDX, IDC_CHECK_ALWAYS_FREE, m_AlwaysFree);
	DDX_Text(pDX, IDC_EDIT_MEMORYTOREACH, m_MemoryToReach);
	DDX_Check(pDX, IDC_CHECK_FREE, m_Free);
	DDX_Check(pDX, IDC_CHECK_REACH, m_Reach);
	//}}AFX_DATA_MAP

	memstat.dwLength = sizeof(MEMORYSTATUS);
	::GlobalMemoryStatus(&memstat);

	// Maximum allowed amount to free
	maxmem = memstat.dwTotalPhys / MBYTE;
	if (maxmem < 1)
		maxmem = 1;

	DDX_Text(pDX, IDC_EDIT_MEMORY, m_Memory);
	DDV_MinMaxUInt(pDX, m_Memory, 0, maxmem);

	DDX_Text(pDX, IDC_EDIT_MEMORYTOREACH, m_MemoryToReach);
	DDV_MinMaxUInt(pDX, m_MemoryToReach, 0, maxmem);

	DDX_Text(pDX, IDC_EDIT_THRESHOLD, m_Threshold);
	DDV_MinMaxUInt(pDX, m_Threshold, 0, maxmem);
}

BEGIN_MESSAGE_MAP(CRAMpageConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CRAMpageConfigDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO_BYTES, OnRadioBytes)
	ON_BN_CLICKED(IDC_RADIO_MBYTES, OnRadioMbytes)
	ON_BN_CLICKED(IDC_RADIO_GREEN, OnRadioGreen)
	ON_BN_CLICKED(IDC_RADIO_NORMAL, OnRadioNormal)
	ON_BN_CLICKED(IDC_RADIO_WHITE, OnRadioWhite)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULTS, OnButtonDefaults)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_BN_CLICKED(IDC_CHECK_RUNHIDDEN, OnCheckRunhidden)
	ON_BN_CLICKED(IDC_RADIO_NEVER, OnRadioNever)
	ON_BN_CLICKED(IDC_RADIO_LOW, OnRadioLow)
	ON_BN_CLICKED(IDC_RADIO_ALWAYS, OnRadioAlways)
	ON_BN_CLICKED(IDC_RADIO_GRAPH1, OnRadioGraph1)
	ON_BN_CLICKED(IDC_RADIO_GRAPH2, OnRadioGraph2)
	ON_BN_CLICKED(IDC_RADIO_GRAPH3, OnRadioGraph3)
	ON_BN_CLICKED(IDC_CHECK_FREE, OnCheckFree)
	ON_BN_CLICKED(IDC_CHECK_REACH, OnCheckReach)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRAMpageConfigDlg message handlers

BOOL CRAMpageConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// RECT rect = {0, 0, 75, 25};
	// CString title;
	// m_TestButton.Create("Test", BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE|WS_TABSTOP, rect, this, 2000 );
	// m_TestButton.SetFont(GetFont(),TRUE);

	// RECT DSrect = {15,232,110,325};
	// title.LoadString(IDS_DISP_STYLE);
	// m_GroupDisplayStyle.Create(title, BS_GROUPBOX|WS_CHILD|WS_VISIBLE, DSrect, this, 1002 );
	// m_GroupDisplayStyle.SetFont(GetFont(),TRUE);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	// TODO: Add extra initialization here
	m_pApp = AfxGetApp( );

	CString m_RegSectionName = REG_SECTION_NAME;

	CString m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_AUTOSTART_VAL);

	SetDefaults();	
	if (m_Value != "")	// Assume previous registry entries exist, since AutoStart must be "Yes" or "No"
	{
		if (!strcmp(m_Value, REG_AUTOSTART_YES))
			m_AutoStart = TRUE;
		else
			m_AutoStart = FALSE;

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_RUNHIDDEN_VAL);
		if (!strcmp(m_Value, REG_RUNHIDDEN_YES))
			m_RunHidden = TRUE;
		else
			m_RunHidden = FALSE;

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_SOUND_VAL);
		if (!strcmp(m_Value, REG_SOUND_YES))
			m_Sound = TRUE;
		else
			m_Sound = FALSE;

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_ALWAYSFREE_VAL);
		if (!strcmp(m_Value, REG_ALWAYSFREE_YES))
			m_AlwaysFree = TRUE;
		else
			m_AlwaysFree = FALSE;

		m_Update = m_pApp->GetProfileInt(m_RegSectionName, REG_UPDATEINTERVAL_VAL, -1);
		if ((int)m_Update == -1)
			m_Update = REG_UPDATEINTERVAL_DEF;

		m_Memory = m_pApp->GetProfileInt(m_RegSectionName, REG_MEMORYTOFREE_VAL, -1);
		if ((int)m_Memory == -1)
			m_Memory = REG_MEMORYTOFREE_DEF;

		m_MemoryToReach = m_pApp->GetProfileInt(m_RegSectionName, REG_MEMORYTOREACH_VAL, -1);
		if ((int)m_MemoryToReach == -1)
			m_MemoryToReach = REG_MEMORYTOREACH_DEF;

		m_Threshold = m_pApp->GetProfileInt(m_RegSectionName, REG_MEMORYTHRESHOLD_VAL, -1);
		if ((int)m_Threshold == -1)
			m_Threshold = REG_MEMORYTHRESHOLD_DEF;

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_DISPLAYSTYLE_VAL);
		if (!strcmp(m_Value, REG_DISPLAYSTYLE_GREEN))
		{
			m_DisplayNormal.SetCheck(0);
			m_DisplayGreen.SetCheck(1);
			m_DisplayWhite.SetCheck(0);
			m_DisplayGraph1.SetCheck(0);
			m_DisplayGraph2.SetCheck(0);
			m_DisplayGraph3.SetCheck(0);
		}
		else if (!strcmp(m_Value, REG_DISPLAYSTYLE_WHITE))
		{
			m_DisplayNormal.SetCheck(0);
			m_DisplayGreen.SetCheck(0);
			m_DisplayWhite.SetCheck(1);
			m_DisplayGraph1.SetCheck(0);
			m_DisplayGraph2.SetCheck(0);
			m_DisplayGraph3.SetCheck(0);
		}
		else if (!strcmp(m_Value, REG_DISPLAYSTYLE_GRAPH1))
		{
			m_DisplayNormal.SetCheck(0);
			m_DisplayGreen.SetCheck(0);
			m_DisplayWhite.SetCheck(0);
			m_DisplayGraph1.SetCheck(1);
			m_DisplayGraph2.SetCheck(0);
			m_DisplayGraph3.SetCheck(0);
		}
		else if (!strcmp(m_Value, REG_DISPLAYSTYLE_GRAPH2))
		{
			m_DisplayNormal.SetCheck(0);
			m_DisplayGreen.SetCheck(0);
			m_DisplayWhite.SetCheck(0);
			m_DisplayGraph1.SetCheck(0);
			m_DisplayGraph2.SetCheck(1);
			m_DisplayGraph3.SetCheck(0);
		}
		else if (!strcmp(m_Value, REG_DISPLAYSTYLE_GRAPH3))
		{
			m_DisplayNormal.SetCheck(0);
			m_DisplayGreen.SetCheck(0);
			m_DisplayWhite.SetCheck(0);
			m_DisplayGraph1.SetCheck(0);
			m_DisplayGraph2.SetCheck(0);
			m_DisplayGraph3.SetCheck(3);
		}
		else	// Assume NORMAL style
		{
			m_DisplayNormal.SetCheck(1);
			m_DisplayGreen.SetCheck(0);
			m_DisplayWhite.SetCheck(0);
			m_DisplayGraph1.SetCheck(0);
			m_DisplayGraph2.SetCheck(0);
			m_DisplayGraph3.SetCheck(0);
		}

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_REACHTARGET_VAL);
		if (!strcmp(m_Value, REG_REACHTARGET_YES))
		{
			m_Free = FALSE;
			m_Reach = TRUE;
		}
		else
		{
			m_Free = TRUE;
			m_Reach = FALSE;
		}

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_DEFRAG_VAL);
		if (!strcmp(m_Value, REG_DEFRAG_ALWAYS))
		{
			m_DefragLow.SetCheck(0);
			m_DefragNever.SetCheck(0);
			m_DefragAlways.SetCheck(1);
		}
		else if (!strcmp(m_Value, REG_DEFRAG_NEVER))
		{
			m_DefragLow.SetCheck(0);
			m_DefragNever.SetCheck(1);
			m_DefragAlways.SetCheck(0);
		}
		else
		{
			m_DefragLow.SetCheck(1);
			m_DefragNever.SetCheck(0);
			m_DefragAlways.SetCheck(0);
		}

		m_Value = m_pApp->GetProfileString(m_RegSectionName, REG_DETAILSTYLE_VAL);
		if (!strcmp(m_Value, REG_DETAILSTYLE_BYTES))
		{
			m_DetailBytes.SetCheck(1);
			m_DetailMBytes.SetCheck(0);
		}
		else	// Assume MBYTES style
		{
			m_DetailBytes.SetCheck(0);
			m_DetailMBytes.SetCheck(1);
		}

	}

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRAMpageConfigDlg::SetRadioDefault(LPSTR lpszDefaultStr, CButton* pRadioBtn) 
{
	if (strlen(lpszDefaultStr))
		pRadioBtn->SetCheck(0);
	else
		pRadioBtn->SetCheck(1);
}

void CRAMpageConfigDlg::SetDefaults() 
{
	MEMORYSTATUS memstat;

	//
	// Get Memory Status Information
	//
	memstat.dwLength = sizeof(MEMORYSTATUS);
	GlobalMemoryStatus(&memstat);

	m_MemoryToReach = 0;
	if (memstat.dwTotalPhys/MBYTE > 130)		// more than ~128M
	{
		m_Memory = 28;
		m_Threshold = 4;
	}
	else if (memstat.dwTotalPhys/MBYTE > 98)	// up to ~128M
	{
		m_Memory = 20;
		m_Threshold = 4;
	}
	else if (memstat.dwTotalPhys/MBYTE > 66)	// up to ~96M
	{
		m_Memory = 16;
		m_Threshold = 4;
	}
	else if (memstat.dwTotalPhys/MBYTE > 42)	// up to ~64M
	{
		m_Memory = 10;
		m_Threshold = 4;
	}
	else if (memstat.dwTotalPhys/MBYTE > 34)	// up to ~40M
	{
		m_Memory = 8;
		m_Threshold = 2;
	}
	else if (memstat.dwTotalPhys/MBYTE > 18)	// up to ~32M
	{
		m_Memory = 4;
		m_Threshold = 2;
	}
	else										// ~16M or less
	{											// (Buy more memory!)
		m_Memory = 3;
		m_Threshold = 1;
	}

	m_Update = REG_UPDATEINTERVAL_DEF;
	SetRadioDefault(CMD_DISPLAYSTYLE_GREEN, &m_DisplayGreen);
	SetRadioDefault(CMD_DISPLAYSTYLE_NORMAL, &m_DisplayNormal);
	SetRadioDefault(CMD_DISPLAYSTYLE_WHITE, &m_DisplayWhite);
	SetRadioDefault(CMD_DISPLAYSTYLE_GRAPH1, &m_DisplayGraph1);
	SetRadioDefault(CMD_DISPLAYSTYLE_GRAPH2, &m_DisplayGraph2);
	SetRadioDefault(CMD_DISPLAYSTYLE_GRAPH3, &m_DisplayGraph3);
	SetRadioDefault(CMD_DEFRAG_LOW, &m_DefragLow);
	SetRadioDefault(CMD_DEFRAG_NEVER, &m_DefragNever);
	SetRadioDefault(CMD_DEFRAG_ALWAYS, &m_DefragAlways);
	SetRadioDefault(CMD_DETAILSTYLE_BYTES, &m_DetailBytes);
	SetRadioDefault(CMD_DETAILSTYLE_MBYTES, &m_DetailMBytes);
	m_AutoStart = TRUE;
	m_RunHidden = FALSE;
	m_Sound = FALSE;
	m_AlwaysFree = FALSE;
	m_Free = TRUE;
	m_Reach = FALSE;
}

void CRAMpageConfigDlg::GetParams(const LPSTR Params, LPSTR Dir) 
{
	char Value [_MAX_PATH];
	char * ptr;

	Params[0] = '\0';
	if (m_Update != REG_UPDATEINTERVAL_DEF)
	{
		sprintf(Value," %s%d", CMD_UPDATEINTERVAL_STR, m_Update);
		strcat(Params, Value);
	}
	if (m_Reach)
	{
		sprintf(Value," %s%d", CMD_MEMORYTOREACH_STR, m_MemoryToReach);
		strcat(Params, Value);
	}
	else
	{
		sprintf(Value," %s%d", CMD_MEMORYTOFREE_STR, m_Memory);
		strcat(Params, Value);
	}

	if (m_Threshold != REG_MEMORYTHRESHOLD_DEF)
	{
		sprintf(Value," %s%d", CMD_MEMORYTHRESHOLD_STR, m_Threshold);
		strcat(Params, Value);
	}

	if (m_Sound && strlen(CMD_SOUND_YES))
	{
		strcat(Params," ");
		strcat(Params,CMD_SOUND_YES);
	}
	else if (strlen(CMD_SOUND_NO))
	{
		strcat(Params," ");
		strcat(Params,CMD_SOUND_NO);
	}

	if (m_AlwaysFree && strlen(CMD_ALWAYSFREE_YES))
	{
		strcat(Params," ");
		strcat(Params,CMD_ALWAYSFREE_YES);
	}
	else if (strlen(CMD_ALWAYSFREE_NO))
	{
		strcat(Params," ");
		strcat(Params,CMD_ALWAYSFREE_NO);
	}

	if (m_DisplayGreen.GetCheck() && strlen(CMD_DISPLAYSTYLE_GREEN))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_GREEN);
	}
	else if (m_DisplayWhite.GetCheck() && strlen(CMD_DISPLAYSTYLE_WHITE))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_WHITE);
	}
	else if (m_DisplayGraph1.GetCheck() && strlen(CMD_DISPLAYSTYLE_GRAPH1))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_GRAPH1);
	}
	else if (m_DisplayGraph2.GetCheck() && strlen(CMD_DISPLAYSTYLE_GRAPH2))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_GRAPH2);
	}
	else if (m_DisplayGraph3.GetCheck() && strlen(CMD_DISPLAYSTYLE_GRAPH3))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_GRAPH3);
	}
	else if (m_DisplayNormal.GetCheck() && strlen(CMD_DISPLAYSTYLE_NORMAL))
	{
		strcat(Params," ");
		strcat(Params,CMD_DISPLAYSTYLE_NORMAL);
	}

	if (m_DefragLow.GetCheck() && strlen(CMD_DEFRAG_LOW))
	{
		strcat(Params," ");
		strcat(Params,CMD_DEFRAG_LOW);
	}
	else if (m_DefragNever.GetCheck() && strlen(CMD_DEFRAG_NEVER))
	{
		strcat(Params," ");
		strcat(Params,CMD_DEFRAG_NEVER);
	}
	else if (m_DefragAlways.GetCheck() && strlen(CMD_DEFRAG_ALWAYS))
	{
		strcat(Params," ");
		strcat(Params,CMD_DEFRAG_ALWAYS);
	}


	if (m_DetailBytes.GetCheck() && strlen(CMD_DETAILSTYLE_BYTES))
	{
		strcat(Params," ");
		strcat(Params,CMD_DETAILSTYLE_BYTES);
	}
	else if (m_DetailMBytes.GetCheck() && strlen(CMD_DETAILSTYLE_MBYTES))
	{
		strcat(Params," ");
		strcat(Params,CMD_DETAILSTYLE_MBYTES);
	}

	Dir[0] = '\0';
	::GetAutoStartRegistryValue(Dir);
	if ((ptr = strstr(Dir," P=\"")) != NULL)
	{
		strcpy(Dir,ptr+4);
		if (strlen(Dir)>strlen("\\RAMpageConfig.exe\""))
			Dir[strlen(Dir)-strlen("\\RAMpageConfig.exe\"")] = '\0';
	}
	else
		GetCurrentDirectory(_MAX_PATH-23-strlen(Params), Dir);

	if (strlen(Dir) && (Dir[strlen(Dir)-1] == '\\'))
		Dir[strlen(Dir)-1] = '\0';

	strcat(Params, " P=\"");
	strcat(Params, Dir);
	strcat(Params, "\\RAMpageConfig.exe\"");
}

void CRAMpageConfigDlg::UpdateRegistry() 
{
	CString m_RegSectionName = REG_SECTION_NAME;
	CString m_Value;
	char Params[_MAX_PATH + 64];
	char Dir[_MAX_PATH];

	if (m_AutoStart)
	{
		GetParams(Params, Dir);
		::AddAutoStartRegistryValue(Params, Dir, m_RunHidden);
		m_Value = REG_AUTOSTART_YES;
	}
	else
	{
		::DeleteAutoStartRegistryValue();
		m_Value = REG_AUTOSTART_NO;
	}

	m_pApp->WriteProfileString(m_RegSectionName, REG_AUTOSTART_VAL, m_Value);

	if (m_RunHidden)
		m_Value = REG_RUNHIDDEN_YES;
	else
		m_Value = REG_RUNHIDDEN_NO;
	m_pApp->WriteProfileString(m_RegSectionName, REG_RUNHIDDEN_VAL, m_Value);

	if (m_Reach)
		m_Value = REG_REACHTARGET_YES;
	else
		m_Value = REG_REACHTARGET_NO;
	m_pApp->WriteProfileString(m_RegSectionName, REG_REACHTARGET_VAL, m_Value);

	if (m_Sound)
		m_Value = REG_SOUND_YES;
	else
		m_Value = REG_SOUND_NO;
	m_pApp->WriteProfileString(m_RegSectionName, REG_SOUND_VAL, m_Value);

	if (m_AlwaysFree)
		m_Value = REG_ALWAYSFREE_YES;
	else
		m_Value = REG_ALWAYSFREE_NO;
	m_pApp->WriteProfileString(m_RegSectionName, REG_ALWAYSFREE_VAL, m_Value);

	if (m_DisplayGreen.GetCheck())
		m_Value = REG_DISPLAYSTYLE_GREEN;
	else if (m_DisplayWhite.GetCheck())
		m_Value = REG_DISPLAYSTYLE_WHITE;
	else if (m_DisplayGraph1.GetCheck())
		m_Value = REG_DISPLAYSTYLE_GRAPH1;
	else if (m_DisplayGraph2.GetCheck())
		m_Value = REG_DISPLAYSTYLE_GRAPH2;
	else if (m_DisplayGraph3.GetCheck())
		m_Value = REG_DISPLAYSTYLE_GRAPH3;
	else
		m_Value = REG_DISPLAYSTYLE_NORMAL;
	m_pApp->WriteProfileString(m_RegSectionName, REG_DISPLAYSTYLE_VAL, m_Value);

	if (m_DefragAlways.GetCheck())
		m_Value = REG_DEFRAG_ALWAYS;
	else if (m_DefragNever.GetCheck())
		m_Value = REG_DEFRAG_NEVER;
	else
		m_Value = REG_DEFRAG_LOW;
	m_pApp->WriteProfileString(m_RegSectionName, REG_DEFRAG_VAL, m_Value);

	if (m_DetailBytes.GetCheck())
		m_Value = REG_DETAILSTYLE_BYTES;
	else
		m_Value = REG_DETAILSTYLE_MBYTES;
	m_pApp->WriteProfileString(m_RegSectionName, REG_DETAILSTYLE_VAL, m_Value);

	m_pApp->WriteProfileInt(m_RegSectionName, REG_UPDATEINTERVAL_VAL,	(int)m_Update);
	m_pApp->WriteProfileInt(m_RegSectionName, REG_MEMORYTOFREE_VAL,		(int)m_Memory);
	m_pApp->WriteProfileInt(m_RegSectionName, REG_MEMORYTOREACH_VAL,	(int)m_MemoryToReach);
	m_pApp->WriteProfileInt(m_RegSectionName, REG_MEMORYTHRESHOLD_VAL,	(int)m_Threshold);
}

void CRAMpageConfigDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRAMpageConfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRAMpageConfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRAMpageConfigDlg::OnRadioBytes() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DetailMBytes.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioMbytes() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DetailBytes.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioGreen() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayNormal.SetCheck(0);
	m_DisplayWhite.SetCheck(0);
	m_DisplayGraph1.SetCheck(0);
	m_DisplayGraph2.SetCheck(0);
	m_DisplayGraph3.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioNormal() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayGreen.SetCheck(0);
	m_DisplayWhite.SetCheck(0);
	m_DisplayGraph1.SetCheck(0);
	m_DisplayGraph2.SetCheck(0);
	m_DisplayGraph3.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioWhite() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayGreen.SetCheck(0);
	m_DisplayNormal.SetCheck(0);
	m_DisplayGraph1.SetCheck(0);
	m_DisplayGraph2.SetCheck(0);
	m_DisplayGraph3.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnButtonDefaults() 
{
	// TODO: Add your control notification handler code here
	SetDefaults();
	// UpdateRegistry();
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnOK() 
{
	// TODO: Add extra validation here
	char Params[_MAX_PATH];
	char ProgramName[_MAX_PATH];
	char Dir[_MAX_PATH];

	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	UpdateRegistry();

	GetParams(Params, Dir);

	strcpy(ProgramName,Dir);

	if (strlen(Dir))
		strcat(ProgramName,"\\");

	if (m_RunHidden)
		strncat(ProgramName,REG_HIDDEN_PROGNAME,_MAX_PATH);
	else
		strncat(ProgramName,REG_NORMAL_PROGNAME,_MAX_PATH);

	::StopRAMpage(50);
	::Sleep(100);
	ShellExecute(
		NULL,	// handle to parent window
		NULL,
		ProgramName,
		Params,	// pointer to string that specifies executable-file parameters 
		Dir,	// pointer to string that specifies default directory
		SW_SHOWNORMAL 	// whether file is shown when opened
		);

	CDialog::OnOK();
}

void CRAMpageConfigDlg::OnButtonHelp() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CRAMpageConfigDlg::OnCheckRunhidden() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))
		return;

	if (m_RunHidden && ((!m_Memory && !m_MemoryToReach) || !m_Threshold))
	{
		m_RunHidden = FALSE;
		UpdateData(FALSE);
		MessageBox(
			"To select \"Run hidden\" you must specify non-zero memory values.",
			"RAMpage",MB_ICONEXCLAMATION|MB_OK);
	}
}

void CRAMpageConfigDlg::OnRadioNever() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DefragLow.SetCheck(0);
	m_DefragAlways.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioLow() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DefragNever.SetCheck(0);
	m_DefragAlways.SetCheck(0);
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioAlways() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DefragLow.SetCheck(0);
	m_DefragNever.SetCheck(0);
	UpdateData(FALSE);
}

void CAboutDlg::OnFaqs() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(
		NULL,	// handle to parent window
		NULL,
		"http://www.jfitz.com/software/RAMpage/RAMpage_FAQS.html",
		NULL,	// pointer to string that specifies executable-file parameters 
		"",	// pointer to string that specifies default directory
		0 	// whether file is shown when opened
		);
}

void CAboutDlg::OnHome() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(
		NULL,	// handle to parent window
		NULL,
		"http://www.jfitz.com/software/RAMpage/index.html",
		NULL,	// pointer to string that specifies executable-file parameters 
		"",	// pointer to string that specifies default directory
		0 	// whether file is shown when opened
		);
}

void CAboutDlg::OnEmail() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(
		NULL,	// handle to parent window
		NULL,
		"mailto:fitz@jfitz.com?subject=RAMpage%20v1.6",
		NULL,	// pointer to string that specifies executable-file parameters 
		"",	// pointer to string that specifies default directory
		0 	// whether file is shown when opened
		);
}

void CRAMpageConfigDlg::OnRadioGraph1() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayGreen.SetCheck(0);
	m_DisplayWhite.SetCheck(0);
	m_DisplayNormal.SetCheck(0);
	m_DisplayGraph2.SetCheck(0);
	m_DisplayGraph3.SetCheck(0);
	m_Update = 1;
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioGraph2() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayGreen.SetCheck(0);
	m_DisplayWhite.SetCheck(0);
	m_DisplayNormal.SetCheck(0);
	m_DisplayGraph1.SetCheck(0);
	m_DisplayGraph3.SetCheck(0);
	m_Update = 1;
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnRadioGraph3() 
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;

	m_DisplayGreen.SetCheck(0);
	m_DisplayWhite.SetCheck(0);
	m_DisplayNormal.SetCheck(0);
	m_DisplayGraph1.SetCheck(0);
	m_DisplayGraph2.SetCheck(0);
	m_Update = 1;
	UpdateData(FALSE);
}


void CRAMpageConfigDlg::OnCheckFree() 
{
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;
	m_Free = TRUE;
	m_Reach = FALSE;
	UpdateData(FALSE);
}

void CRAMpageConfigDlg::OnCheckReach() 
{
	if (!UpdateData(TRUE))	// Check that the data validated okay
		return;
	m_Free = FALSE;
	m_Reach = TRUE;
	UpdateData(FALSE);
}
