#define REG_COMPANY_NAME			"RAMpage"
#define REG_APP_NAME				"RAMpage"
#define REG_SECTION_NAME			"Settings"

#define REG_UPDATEINTERVAL_VAL		"UpdateInterval"
#define REG_UPDATEINTERVAL_DEF		5
#define CMD_UPDATEINTERVAL_STR		"U="

#define REG_MEMORYTOFREE_VAL		"MemoryToFree"
#define REG_MEMORYTOFREE_DEF		0
#define CMD_MEMORYTOFREE_STR		"M="

#define REG_MEMORYTOREACH_VAL		"MemoryToReach"
#define REG_MEMORYTOREACH_DEF		0
#define CMD_MEMORYTOREACH_STR		"R="

#define REG_MEMORYTHRESHOLD_VAL		"MemoryThreshold"
#define REG_MEMORYTHRESHOLD_DEF		0
#define CMD_MEMORYTHRESHOLD_STR		"T="

#define REG_DISPLAYSTYLE_VAL		"DisplayStyle"
#define REG_DISPLAYSTYLE_NORMAL		"Normal"
#define REG_DISPLAYSTYLE_GREEN		"Green"
#define REG_DISPLAYSTYLE_WHITE		"White"
#define REG_DISPLAYSTYLE_GRAPH1		"Graph1"
#define REG_DISPLAYSTYLE_GRAPH2		"Graph2"
#define REG_DISPLAYSTYLE_GRAPH3		"Graph3"
#define CMD_DISPLAYSTYLE_NORMAL		""
#define CMD_DISPLAYSTYLE_GREEN		"LG"
#define CMD_DISPLAYSTYLE_WHITE		"LW"
#define CMD_DISPLAYSTYLE_GRAPH1		"G=1"
#define CMD_DISPLAYSTYLE_GRAPH2		"G=2"
#define CMD_DISPLAYSTYLE_GRAPH3		"G=3"

#define REG_DETAILSTYLE_VAL			"DetailStyle"
#define REG_DETAILSTYLE_MBYTES		"MBytes"
#define REG_DETAILSTYLE_BYTES		"Bytes"
#define CMD_DETAILSTYLE_MBYTES		""
#define CMD_DETAILSTYLE_BYTES		"B"

#define REG_AUTOSTART_VAL			"AutoStart"
#define REG_AUTOSTART_YES			"Yes"
#define REG_AUTOSTART_NO			"No"

#define REG_RUNHIDDEN_VAL			"RunHidden"
#define REG_RUNHIDDEN_YES			"Yes"
#define REG_RUNHIDDEN_NO			"No"

#define REG_SOUND_VAL				"Sound"
#define REG_SOUND_YES				"Yes"
#define REG_SOUND_NO				"No"
#define CMD_SOUND_YES				"S"
#define CMD_SOUND_NO				""

#define REG_REACHTARGET_VAL			"ReachTarget"
#define REG_REACHTARGET_YES			"Yes"
#define REG_REACHTARGET_NO			"No"
#define REG_REACHTARGET_DEF			"No"

#define REG_ALWAYSFREE_VAL			"AlwaysFree"
#define REG_ALWAYSFREE_YES			"Yes"
#define REG_ALWAYSFREE_NO			"No"
#define CMD_ALWAYSFREE_YES			"A"
#define CMD_ALWAYSFREE_NO			""

#define REG_DEFRAG_VAL				"Defragment"
#define REG_DEFRAG_LOW				"Low"
#define REG_DEFRAG_NEVER			"Never"
#define REG_DEFRAG_ALWAYS			"Always"
#define CMD_DEFRAG_LOW				""
#define CMD_DEFRAG_NEVER			"D=N"
#define CMD_DEFRAG_ALWAYS			"D=Y"

#define REG_NORMAL_PROGNAME			"RAMpage.exe"
#define REG_HIDDEN_PROGNAME			"RAMpageH.exe"

void DeleteRegistryValues();
void GetAutoStartRegistryValue(LPSTR lpszValue);
void AddAutoStartRegistryValue(const LPSTR lpszParams, const LPSTR lpszDir, BOOL RunHidden);
void DeleteAutoStartRegistryValue();
void StopRAMpage(unsigned int PauseMilliseconds);
void RemoveRAMpage();
