// RAMpageConfigDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRAMpageConfigDlg dialog

class CRAMpageConfigDlg : public CDialog
{
// Construction
public:
	CRAMpageConfigDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRAMpageConfigDlg)
	enum { IDD = IDD_RAMPAGECONFIG_DIALOG };
	CButton	m_ButtonDefaults;
	CButton	m_DisplayGraph3;
	CButton	m_DisplayGraph2;
	CButton	m_DisplayGraph1;
	CButton	m_DefragNever;
	CButton	m_DefragLow;
	CButton	m_DefragAlways;
	CButton	m_DetailBytes;
	CButton	m_DisplayWhite;
	CButton	m_DisplayNormal;
	CButton	m_DisplayGreen;
	CButton	m_DetailMBytes;
	UINT	m_Memory;
	UINT	m_Threshold;
	UINT	m_Update;
	BOOL	m_AutoStart;
	CWinApp* m_pApp;	// We need the Application handle to get/set registry entries.
	BOOL	m_RunHidden;
	BOOL	m_Sound;
	BOOL	m_AlwaysFree;
	UINT	m_MemoryToReach;
	BOOL	m_Free;
	BOOL	m_Reach;
	//}}AFX_DATA
//	CButton m_TestButton;
//	CButton m_GroupDisplayStyle;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRAMpageConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CString m_Space;

	// Generated message map functions
	//{{AFX_MSG(CRAMpageConfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRadioBytes();
	afx_msg void OnRadioMbytes();
	afx_msg void OnRadioGreen();
	afx_msg void OnRadioNormal();
	afx_msg void OnRadioWhite();
	afx_msg void OnButtonDefaults();
	virtual void OnOK();
	afx_msg void OnButtonHelp();
	afx_msg void OnCheckRunhidden();
	afx_msg void OnRadioNever();
	afx_msg void OnRadioLow();
	afx_msg void OnRadioAlways();
	afx_msg void OnRadioGraph1();
	afx_msg void OnRadioGraph2();
	afx_msg void OnRadioGraph3();
	afx_msg void OnCheckFree();
	afx_msg void OnCheckReach();
	//}}AFX_MSG
	void GetParams(const LPSTR Params, LPSTR Dir);
	void SetDefaults();
	void SetRadioDefault(LPSTR lpszDefaultStr, CButton* pRadioBtn);
	void UpdateRegistry();
	void DeleteRegistryKeys();
	DECLARE_MESSAGE_MAP()
};
