/* 
**	rr - "Run and Release" utility for RAMpage
**
**	File:    rr.c
**	Author:  John Fitzgibbon (fitz@jfitz.com http://www.jfitz.com)
**	Version: 1.0
**	Date:    05/01/2001
**	Credits: ShellExecuteEx/WaitForSingleObject details courtesy of 
**           Jason Hood (jadoxa@hotmail.com)
**
**	This program and code is FREEWARE, but please give credit where credit is due.
**
**  Revision History
**  05/01/2001 1.0 - Original Version 
*/

#include <windows.h>
#include <shellapi.h>
#include <stdio.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
	SHELLEXECUTEINFO sei;
	HWND hWnd;
	LRESULT msgr;

	memset(&sei, 0, sizeof(sei));
	sei.cbSize = sizeof(sei);
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.lpFile = strtok(lpszCmdLine,"\"");
	sei.lpParameters = strtok(NULL,"");
	sei.nShow = nCmdShow;
	if ((ShellExecuteEx(&sei) != 0) && (sei.hProcess != 0))
	{
		WaitForSingleObject(sei.hProcess, INFINITE);
		Sleep(100);
		if ((hWnd = FindWindow (NULL,"RAMpage")) != NULL)
			msgr = SendMessage(hWnd, (WM_USER + 1), (WPARAM) 0, (LPARAM) WM_LBUTTONDBLCLK);
	}

	return 0;
}	
